Index: XIOS/dev/dev_olga/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/field.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/node/field.cpp	(revision 1009)
@@ -123,5 +123,66 @@
     CContext* context = CContext::getCurrent();
 //    CContextClient* client = context->client;
-    CContextClient* client = (!context->hasServer) ? context->client : context->clientPrimServer;
+    int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+    for (int i = 0; i < nbSrvPools; ++i)
+    {
+      CContextClient* client = (!context->hasServer) ? context->client : context->clientPrimServer[i];
+
+      CEventClient event(getType(), EVENT_ID_UPDATE_DATA);
+
+      map<int, CArray<int,1> >::iterator it;
+      list<CMessage> list_msg;
+      list<CArray<double,1> > list_data;
+
+      if (!grid->doGridHaveDataDistributed())
+      {
+         if (client->isServerLeader())
+         {
+            for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
+            {
+              int rank = it->first;
+              CArray<int,1>& index = it->second;
+
+              list_msg.push_back(CMessage());
+              list_data.push_back(CArray<double,1>(index.numElements()));
+
+              CArray<double,1>& data_tmp = list_data.back();
+              for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
+
+              list_msg.back() << getId() << data_tmp;
+              event.push(rank, 1, list_msg.back());
+            }
+            client->sendEvent(event);
+         }
+         else client->sendEvent(event);
+      }
+      else
+      {
+        for (it = grid->storeIndex_toSrv.begin(); it != grid->storeIndex_toSrv.end(); it++)
+        {
+          int rank = it->first;
+          CArray<int,1>& index = it->second;
+
+          list_msg.push_back(CMessage());
+          list_data.push_back(CArray<double,1>(index.numElements()));
+
+          CArray<double,1>& data_tmp = list_data.back();
+          for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
+
+          list_msg.back() << getId() << data_tmp;
+          event.push(rank, grid->nbSenders[rank], list_msg.back());
+        }
+        client->sendEvent(event);
+      }
+    }
+
+    CTimer::get("XIOS Send Data").suspend();
+  }
+
+  void CField::sendUpdateData(const CArray<double,1>& data, const int srvPool)
+  {
+    CTimer::get("XIOS Send Data").resume();
+
+    CContext* context = CContext::getCurrent();
+    CContextClient* client = context->clientPrimServer[srvPool];
 
     CEventClient event(getType(), EVENT_ID_UPDATE_DATA);
@@ -150,5 +211,5 @@
           }
           client->sendEvent(event);
-       } 
+       }
        else client->sendEvent(event);
     }
@@ -171,5 +232,4 @@
       client->sendEvent(event);
     }
-
     CTimer::get("XIOS Send Data").suspend();
   }
@@ -248,8 +308,24 @@
 //      else
         this->outputField(fieldData);
-      sendUpdateData(fieldData);
+//        sendUpdateData(fieldData);
+        // Redirecting data to the correct secondary server
+        int fileIdx = std::find(context->enabledFiles.begin(), context->enabledFiles.end(), this->file) - context->enabledFiles.begin();
+        int srvId = fileIdx % context->clientPrimServer.size();
+        sendUpdateData(fieldData, srvId);
     }
     if (!context->hasClient && context->hasServer)
     {
+//      size_t writtenSize;
+//      if (this->getUseCompressedOutput())
+//        writtenSize = grid->getNumberWrittenIndexes();
+//      else
+//        writtenSize = grid->getWrittenDataSize();
+//
+//      CArray<double,1> fieldData(writtenSize);
+
+//      if (this->getUseCompressedOutput())
+//        this->outputCompressedField(fieldData);
+//      else
+//        this->outputField(fieldData);
       writeField();
     }
@@ -1249,4 +1325,18 @@
    }
 
+   void CField::sendAddAllVariables(const int srvPool)
+   {
+     std::vector<CVariable*> allVar = getAllVariables();
+     std::vector<CVariable*>::const_iterator it = allVar.begin();
+     std::vector<CVariable*>::const_iterator itE = allVar.end();
+
+     for (; it != itE; ++it)
+     {
+       this->sendAddVariable((*it)->getId());
+       (*it)->sendAllAttributesToServer(srvPool);
+       (*it)->sendValue(srvPool);
+     }
+   }
+
    void CField::sendAddVariable(const string& id)
    {
Index: XIOS/dev/dev_olga/src/node/field.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/field.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/node/field.hpp	(revision 1009)
@@ -139,4 +139,5 @@
         static bool dispatchEvent(CEventServer& event);
         void sendUpdateData(const CArray<double,1>& data);
+        void sendUpdateData(const CArray<double,1>& data, const int srvPool);
         static void recvUpdateData(CEventServer& event);
         void recvUpdateData(vector<int>& ranks, vector<CBufferIn*>& buffers);
@@ -168,4 +169,5 @@
         CVariableGroup* addVariableGroup(const string& id = "");
         void sendAddVariable(const string& id = "");
+        void sendAddVariable(const string& id, const int srvPool);
         void sendAddVariableGroup(const string& id = "");
         static void recvAddVariable(CEventServer& event);
@@ -174,4 +176,5 @@
         void recvAddVariableGroup(CBufferIn& buffer);
         void sendAddAllVariables();
+        void sendAddAllVariables(const int srvPool);
 
 
Index: XIOS/dev/dev_olga/src/node/file.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/file.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/node/file.cpp	(revision 1009)
@@ -235,6 +235,8 @@
       const int recordOffset = record_offset.isEmpty() ? 0 : record_offset;
 
-      set<CAxis*> setAxis;
-      set<CDomain*> setDomains;
+//      set<CAxis*> setAxis;
+//      set<CDomain*> setDomains;
+      set<StdString> setAxis;
+      set<StdString> setDomains;
 
       std::vector<CField*>::iterator it, end = this->enabledFields.end();
@@ -245,8 +247,10 @@
          std::vector<CAxis*> vecAxis = field->grid->getAxis();
          for (size_t i = 0; i < vecAxis.size(); ++i)
-            setAxis.insert(vecAxis[i]);
+           setAxis.insert(vecAxis[i]->getAxisOutputName());
+//            setAxis.insert(vecAxis[i]);
          std::vector<CDomain*> vecDomains = field->grid->getDomains();
          for (size_t i = 0; i < vecDomains.size(); ++i)
-            setDomains.insert(vecDomains[i]);
+           setDomains.insert(vecDomains[i]->getDomainOutputName());
+//            setDomains.insert(vecDomains[i]);
 
          field->resetNStep(recordOffset);
@@ -849,4 +853,29 @@
    }
 
+   void CFile::sendAddField(const string& id, const int srvPool)
+   {
+      sendAddItem(id, EVENT_ID_ADD_FIELD, srvPool);
+    // CContext* context = CContext::getCurrent();
+
+    // if (! context->hasServer )
+    // {
+    //    CContextClient* client = context->client;
+
+    //    CEventClient event(this->getType(),EVENT_ID_ADD_FIELD);
+    //    if (client->isServerLeader())
+    //    {
+    //      CMessage msg;
+    //      msg << this->getId();
+    //      msg << id;
+    //      const std::list<int>& ranks = client->getRanksServerLeader();
+    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+    //        event.push(*itRank,1,msg);
+    //      client->sendEvent(event);
+    //    }
+    //    else client->sendEvent(event);
+    // }
+
+   }
+
    /*!
    \brief Send a message to create a field group on server side
@@ -945,4 +974,46 @@
    }
 
+   void CFile::sendAddAllVariables(const int srvPool)
+   {
+     std::vector<CVariable*> allVar = getAllVariables();
+     std::vector<CVariable*>::const_iterator it = allVar.begin();
+     std::vector<CVariable*>::const_iterator itE = allVar.end();
+
+     for (; it != itE; ++it)
+     {
+       this->sendAddVariable((*it)->getId(), srvPool);
+       (*it)->sendAllAttributesToServer(srvPool);
+       (*it)->sendValue(srvPool);
+     }
+   }
+
+   /*!
+   \brief Send a message to create a variable group on server side
+   \param[in] id String identity of variable group that will be created on server
+   */
+   void CFile::sendAddVariableGroup(const string& id)
+   {
+      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE_GROUP);
+    // CContext* context = CContext::getCurrent();
+    // if (! context->hasServer )
+    // {
+    //    CContextClient* client = context->client;
+
+    //    CEventClient event(this->getType(),EVENT_ID_ADD_VARIABLE_GROUP);
+    //    if (client->isServerLeader())
+    //    {
+    //      CMessage msg;
+    //      msg << this->getId();
+    //      msg << id;
+    //      const std::list<int>& ranks = client->getRanksServerLeader();
+    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+    //        event.push(*itRank,1,msg);
+    //      client->sendEvent(event);
+    //    }
+    //    else client->sendEvent(event);
+    // }
+
+   }
+
    /*!
    \brief Send a message to create a variable on server side
@@ -975,17 +1046,14 @@
    }
 
-   /*!
-   \brief Send a message to create a variable group on server side
-   \param[in] id String identity of variable group that will be created on server
-   */
-   void CFile::sendAddVariableGroup(const string& id)
-   {
-      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE_GROUP);
+   void CFile::sendAddVariable(const string& id, const int srvPool)
+   {
+      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, srvPool);
     // CContext* context = CContext::getCurrent();
+
     // if (! context->hasServer )
     // {
     //    CContextClient* client = context->client;
 
-    //    CEventClient event(this->getType(),EVENT_ID_ADD_VARIABLE_GROUP);
+    //    CEventClient event(this->getType(),EVENT_ID_ADD_VARIABLE);
     //    if (client->isServerLeader())
     //    {
@@ -1070,4 +1138,16 @@
    }
 
+   void CFile::sendEnabledFields(const int srvPool)
+   {
+     size_t size = this->enabledFields.size();
+     for (size_t i = 0; i < size; ++i)
+     {
+       CField* field = this->enabledFields[i];
+       this->sendAddField(field->getId(), srvPool);
+       field->sendAllAttributesToServer(srvPool);
+       field->sendAddAllVariables(srvPool);
+     }
+   }
+
    /*!
    \brief Dispatch event received from client
Index: XIOS/dev/dev_olga/src/node/file.hpp
===================================================================
--- XIOS/dev/dev_olga/src/node/file.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/node/file.hpp	(revision 1009)
@@ -117,8 +117,12 @@
          // Send info to server
          void sendEnabledFields();
+         void sendEnabledFields(const int srvPool);
          void sendAddField(const string& id = "");
+         void sendAddField(const string& id, const int srvPool);
          void sendAddFieldGroup(const string& id = "");
          void sendAddAllVariables();
+         void sendAddAllVariables(const int srvPool);
          void sendAddVariable(const string& id = "");
+         void sendAddVariable(const string& id, const int srvPool);
          void sendAddVariableGroup(const string& id = "");
 
